Package com.ads.api.util

# Class CodesetManagerUtil

java.lang.Object
com.ads.api.util.BaseUtil
com.ads.api.util.CodesetManagerUtil

public class CodesetManagerUtil extends com.ads.api.util.BaseUtil
Contains the methods related to perform the operations such as creation, update, deletion and retrieval of Categories, Codesets, Code Mappings, Code Values etc.

RequestStatus as return type methods will result in being returned as either true or false as its status.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.ads.api.util.BaseUtil

  `com.ads.api.util.BaseUtil.TokenType`

- ## Field Summary

  ### Fields inherited from class com.ads.api.util.BaseUtil

  `AUTH_TOKEN, AUTH_TOKEN_TYPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `RequestStatus`
  `addCodeValue(int codesetId, CodeValue codeValue, boolean saveExtendedProperties)`
  Codevalue is added for the specified codesetId, codevalue object and also extended properties are added only if the saveExtendedProperties flag is true.
  `RequestStatus`
  `addCodeValue(CodeValue codeValue, boolean saveExtendedProperties)`
  Codevalue is added for the specified codevalue object and also extended properties are added only if the saveExtendedProperties flag is true.
  `String`
  `addCodeValueAs(String codeValue, boolean saveExtendedProperties, String outputFormat)`
  Codevalue is added for the specified codeValue object and also extended properties are added only if the saveExtendedProperties flag is true.
  `RequestStatus`
  `addCodeValues(int codesetId, List<CodeValue> codeValues, boolean saveExtendedProperties)`
  Codevalues are added for the specified codesetId list of codevalue objects and also extended properties are added only if the saveExtendedProperties flag is true.
  `RequestStatus`
  `addCodeValues(List<CodeValue> codeValues, boolean saveExtendedProperties)`
  Codevalues are added for the specified list of codevalue objects and also extended properties are added only if the saveExtendedProperties flag is true.
  `String`
  `addCodeValuesAs(String codeValues, boolean saveExtendedProperties, String outputFormat)`
  Codevalues are added for the specified list of codeValue objects and also extended properties are added only if the saveExtendedProperties flag is true.
  `RequestStatus`
  `assignCodeset(Node.NodeType nodeType, int nodeId, Codeset codeset)`
  Assigns the specified codeset object to the specified nodeType and nodeId.
  `String`
  `assignCodesetAs(String nodeType, int nodeId, String codeset, String outputFormat)`
  Assigns the specified codeset object to the specified nodeType and nodeId.
  `RequestStatus`
  `assignCodesets(Node.NodeType nodeType, int nodeId, List<Codeset> codesets)`
  Assigns the specified list of codesets to the specified nodeType and nodeId.
  `RequestStatus`
  `assignCodesets(Node.NodeType nodeType, int nodeId, List<Integer> codesetIds, boolean unassignExisting)`
  Assigns codesets of specified codeset ids to the specified nodeType and nodeId.
  `String`
  `assignCodesetsAs(String nodeType, int nodeId, String codesetIds, boolean unassignExisting, String outputFormat)`
  Assigns codesets of specified codeset ids to the specified nodeType and nodeId.
  `RequestStatus`
  `cloneCodeset(int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists)`
  Codeset is cloned for the given srcCodesetId to the given tgtCategoryId.
  `String`
  `cloneCodesetAs(int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists, String outputFormat)`
  Codeset is cloned for the given srcCodesetId to the given tgtCategoryId.
  `RequestStatus`
  `createCategories(List<Category> categories)`
  Categories are added for the specified list of category objects.
  `String`
  `createCategoriesAs(String categories, String outputFormat)`
  Categories are added for the specified list of category objects.
  `RequestStatus`
  `createCategory(int parentCategoryId, Category.Type categoryType, String categoryName)`
  Category is added for the specified categoryName and categoryType.
  `RequestStatus`
  `createCategory(Category category)`
  Category is added for the specified category object.
  `String`
  `createCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)`
  Category is added for the specified categoryName and categoryType.
  `String`
  `createCategoryAs(String category, String outputFormat)`
  Category is added for the specified category object.
  `RequestStatus`
  `createCodeset(int categoryId, Codeset codeset, boolean saveCodeValues)`
  Codeset is added for the specified categoryId, codeset object and also code values are added only if the saveCodeValues flag is true.
  `RequestStatus`
  `createCodeset(Codeset codeset, boolean saveCodeValues)`
  Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true.
  `String`
  `createCodesetAs(String codeset, boolean saveCodeValues, String outputFormat)`
  Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true.
  `RequestStatus`
  `createCodesets(int categoryId, List<Codeset> codesets, boolean saveCodeValues)`
  Codesets are added for the specified list of codeset objects and also code values are added only if the saveCodeValues flag is true.
  `RequestStatus`
  `createCodesets(List<Codeset> codesets, boolean saveCodeValues)`
  Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true.
  `String`
  `createCodesetsAs(String codesets, boolean saveCodeValues, String outputFormat)`
  Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true.
  `RequestStatus`
  `createEnvironment(CSMEnvironment csmEnvironment)`
  CSMEnvironment is added for the specified environment object.
  `String`
  `createEnvironmentAs(String environment, String outputFormat)`
  CSMEnvironment is added for the specified environment object.
  `RequestStatus`
  `createEnvironments(List<CSMEnvironment> csmEnvironments)`
  List of environments are added for the specified list of environment objects.
  `String`
  `createEnvironmentsAs(String environments, String outputFormat)`
  List of environments are added for the specified list of environment objects.
  `RequestStatus`
  `deleteCategories(List<Integer> categoryIds, Category.Type categoryType)`
  Deletes the categories with the specified list of categoryIds and categoryType.
  `String`
  `deleteCategoriesAs(String categoryIds, String categoryType, String outputFormat)`
  Deletes the categories with the specified list of categoryIds and categoryType.
  `RequestStatus`
  `deleteCategory(int categoryId, Category.Type categoryType)`
  Deletes the category with the specified categoryId and categoryType.
  `RequestStatus`
  `deleteCategory(int parentCategoryId, Category.Type categoryType, String categoryName)`
  Deletes the category with the specified categoryName and categoryType.
  `RequestStatus`
  `deleteCategory(Category category)`
  Deletes the category with the specified category object.
  `String`
  `deleteCategoryAs(int categoryId, String categoryType, String outputFormat)`
  Deletes the category with the specified categoryId and categoryType.
  `String`
  `deleteCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)`
  Deletes the category with the specified categoryName and categoryType.
  `RequestStatus`
  `deleteCodeset(int codesetId)`
  Deletes the codeset with the specified codesetId.Specifying the codesetId is mandatory to delete a particular codeset.
  `RequestStatus`
  `deleteCodeset(int codesetId, APIConstants.VersionMode versionMode)`
  Deletes the codeset with the specified codesetId and versionMode.
  `RequestStatus`
  `deleteCodeset(Codeset codeset)`
  Deletes the codeset with the specified codeset object.
  `String`
  `deleteCodesetAs(int codesetId, String outputFormat)`
  Deletes the codeset with the specified codesetId.Specifying the codesetId is mandatory to delete a particular codeset.
  `String`
  `deleteCodesetAs(int codesetId, String versionMode, String outputFormat)`
  Deletes the codeset with the specified codesetId and versionMode.
  `RequestStatus`
  `deleteCodesets(int categoryId)`
  Deletes the list of codesets for the given categoryId.
  `RequestStatus`
  `deleteCodesets(int categoryId, APIConstants.VersionMode versionMode)`
  Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets.
  `RequestStatus`
  `deleteCodesets(int categoryId, List<String> codesetNames, APIConstants.VersionMode versionMode)`
  Deletes the list of codesets for the specified categoryId, codesetNames list and versionMode.
  `RequestStatus`
  `deleteCodesets(List<Integer> codesetIds)`
  Deletes the codesets with the specified list of codesetIds.
  `RequestStatus`
  `deleteCodesets(List<Integer> codesetIds, APIConstants.VersionMode versionMode)`
  Deletes the codeset with the specified codesetIds list and versionMode.
  `String`
  `deleteCodesetsAs(int categoryId, String outputFormat)`
  Deletes the list of codesets for the given categoryId.
  `String`
  `deleteCodesetsAs(int categoryId, String versionMode, String outputFormat)`
  Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets.
  `String`
  `deleteCodesetsAs(int categoryId, String codesetNames, String versionMode, String outputFormat)`
  Deletes the list of codesets for the specified categoryId, codesetNames and versionMode.
  `String`
  `deleteCodesetsAs(String codesetIds, String outputFormat)`
  Deletes the codesets with the specified list of codesetIds.
  `String`
  `deleteCodesetsAs(String codesetIds, String versionMode, String outputFormat)`
  Deletes the codesets with the specified codesetIds list and versionMode.
  `RequestStatus`
  `deleteCodeValue(int codeValueId, APIConstants.DeleteMode deleteMode)`
  Deletes the code value with the specified codeValueId and deleteMode.
  `String`
  `deleteCodeValueAs(int codeValueId, String deleteMode, String outputFormat)`
  Deletes the codevalue object with the specified codeValueId and deleteMode.
  `RequestStatus`
  `deleteCodeValues(int codesetId, APIConstants.DeleteMode deleteMode)`
  Deletes the list of codevalue objects with the specified codesetId and deleteMode.
  `RequestStatus`
  `deleteCodeValues(List<Integer> codeValueIds, APIConstants.DeleteMode deleteMode)`
  Deletes the list of code value objects with the specified codeValueIds list and deleteMode.
  `String`
  `deleteCodeValuesAs(int codesetId, String deleteMode, String outputFormat)`
  Deletes the list of codevalue objects with the specified codesetId and deleteMode.
  `String`
  `deleteCodeValuesAs(String codeValueIds, String deleteMode, String outputFormat)`
  Deletes the list of codeValue objects with the specified codeValueIds list and deleteMode.
  `RequestStatus`
  `deleteEnvironment(int environmentId)`
  Deletes the environment with the specified environmentId.
  `RequestStatus`
  `deleteEnvironment(CSMEnvironment csmEnvironment)`
  Deletes the environment with the specified environmen object.
  `RequestStatus`
  `deleteEnvironment(String environmentName)`
  Deletes the environment with the specified environmentName.
  `String`
  `deleteEnvironmentAs(int environmentId, String outputFormat)`
  Deletes the environment with the specified environmentId.
  `String`
  `deleteEnvironmentAs(String environmentName, String outputFormat)`
  Deletes the environment with the specified environmentName.
  `RequestStatus`
  `deleteEnvironments(List<Integer> environmentIds)`
  Deletes the environments with the specified list of environmentIds.
  `String`
  `deleteEnvironmentsAs(String environmentIds, String outputFormat)`
  Deletes the environments with the specified list of environmentIds.
  `RequestStatus`
  `exportAll()`
  All the codesets present in enterprise codesets are exported to excel.
  `String`
  `exportAllAs(String outputFormat)`
  All the codesets present in enterprise codesets are exported to excel.
  `RequestStatus`
  `exportCodesets(int categoryId, boolean includeSubCategories)`
  Codesets are exported to excel for the specified categoryId.
  `String`
  `exportCodesetsAs(int categoryId, boolean includeSubCategories, String outputFormat)`
  Codesets are exported to excel for the specified categoryId.
  `RequestStatus`
  `exportCodeValues(int codesetId)`
  Codevalues are exported to excel for the specified codesetId.
  `String`
  `exportCodeValuesAs(int codesetId, String outputFormat)`
  Codevalues are exported to excel for the specified codesetId.
  `List<Codeset>`
  `getAllRetiredCodesets()`
  Returns the list of all retired codesets present in enterprise codesets.
  `String`
  `getAllRetiredCodesetsAs(String outputFormat)`
  Returns the list of all retired codesets present in enterprise codesets.
  `List<Codeset>`
  `getAssignedCodesets(Node.NodeType nodeType, int nodeId)`
  Returns the list of codeset objects for the specified nodeType and nodeId where each codeset object contains codeset name, codeset description, codeset status and category name in which codeset is present etc...
  `List<Codeset>`
  `getAssignedCodesets(Node.NodeType nodeType, int nodeId, int fillOptions)`
  Returns the list of codeset objects for the specified nodeType and nodeId.
  `String`
  `getAssignedCodesetsAs(String nodeType, int nodeId, int fillOptions, String outputFormat)`
  Returns the list of codeset objects for the specified nodeType and nodeId.
  `List<Category>`
  `getCategories(List<Integer> categoryIds, Category.Type categoryType)`
  Returns the list of category objects for the specified categoryIds list and categoryType.
  `List<Category>`
  `getCategories(List<Integer> categoryIds, Category.Type categoryType, int fillOptions)`
  Returns the list of category objects for the specified categoryIds list and categoryType.
  `String`
  `getCategoriesAs(String categoryIds, String categoryType, int fillOptions, String outputFormat)`
  Returns the list of category objects for the specified categoryIds list and categoryType.Specifying the categoryIds list and categoryType are mandatory.
  `Category`
  `getCategory(int categoryId, Category.Type categoryType)`
  Returns the category object for the specified categoryId and categoryType.
  `Category`
  `getCategory(int categoryId, Category.Type categoryType, int fillOptions)`
  Returns the category object for the specified categoryId and categoryType.
  `Category`
  `getCategory(int parentCategoryId, Category.Type categoryType, String categoryName)`
  Returns the category object for the specified parentCategoryId, categoryType and categoryName.
  `String`
  `getCategoryAs(int categoryId, String categoryType, int fillOptions, String outputFormat)`
  Returns the category object for the specified categoryId and categoryType.
  `String`
  `getCategoryAs(int categoryId, String categoryType, String outputFormat)`
  Returns the category object for the specified categoryId and categoryType.
  `String`
  `getCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)`
  Returns the category object for the specified parentCategoryId, categoryType and categoryName.
  `int`
  `getCategoryId(int parentCategoryId, Category.Type categoryType, String categoryName)`
  Returns the category id for the given categoryName and categoryType.
  `String`
  `getCategoryIdAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)`
  Returns the category id for the specified categoryName and categoryType.
  `Codeset`
  `getCodeset(int codesetId)`
  Returns the codeset object for the specified codesetId.
  `Codeset`
  `getCodeset(int codesetId, int fillOptions)`
  Returns the codeset object for the specified codesetId.
  `Codeset`
  `getCodeset(int categoryId, String codesetName)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `Codeset`
  `getCodeset(int categoryId, String codesetName, float version)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `Codeset`
  `getCodeset(int categoryId, String codesetName, float version, int fillOptions)`
  Returns the codeset object for the specified categoryId, codesetName and version.
  `Codeset`
  `getCodeset(int categoryId, String codesetName, int fillOptions)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `String`
  `getCodesetAs(int codesetId, int fillOptions, String outputFormat)`
  Returns the codeset object for the specified codesetId.
  `String`
  `getCodesetAs(int codesetId, String outputFormat)`
  Returns the codeset object for the specified codesetId.
  `String`
  `getCodesetAs(int categoryId, String codesetName, float version, int fillOptions, String outputFormat)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `String`
  `getCodesetAs(int categoryId, String codesetName, float version, String outputFormat)`
  Returns the codeset object for the specified categoryId, codesetName and version.
  `String`
  `getCodesetAs(int categoryId, String codesetName, int fillOptions, String outputFormat)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `String`
  `getCodesetAs(int categoryId, String codesetName, String outputFormat)`
  Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory.
  `int`
  `getCodesetId(int categoryId, String codesetName)`
  Returns the codeset id for the specified categoryId and codesetName.
  `String`
  `getCodesetIdAs(int categoryId, String codesetName, String outputFormat)`
  Returns the codeset id for the specified categoryId and codesetName.
  `List<Codeset>`
  `getCodesets(int categoryId)`
  Returns the list of codeset objects for the specified categoryId.
  `List<Codeset>`
  `getCodesets(int categoryId, int fillOptions)`
  Returns the list of codeset objects for the specified categoryId.
  `List<Codeset>`
  `getCodesets(List<Integer> codesetIds)`
  Returns the list of codeset objects for the specified codesetIds list.
  `List<Codeset>`
  `getCodesets(List<Integer> codesetIds, int fillOptions)`
  Returns the list of codeset objects for the specified codesetIds list.
  `String`
  `getCodesetsAs(int categoryId, int fillOptions, String outputFormat)`
  Returns the list of codeset objects for the specified categoryId.
  `String`
  `getCodesetsAs(int categoryId, String outputFormat)`
  Returns the list of codeset objects for the specified categoryId.
  `String`
  `getCodesetsAs(String codesetIds, int fillOptions, String outputFormat)`
  Returns the list of codeset objects for the specified codesetIds list.
  `String`
  `getCodesetsAs(String codesetIds, String outputFormat)`
  Returns the list of codeset objects for the specified codesetIds list.
  `List<CodeValue>`
  `getCodeValues(int codesetId)`
  Returns the list of codevalue objects for the specified codesetId.
  `List<CodeValue>`
  `getCodeValues(int codesetId, int fillOptions)`
  Returns the list of codevalue objects for the specified codesetId.
  `List<CodeValue>`
  `getCodeValues(int categoryId, String codesetName)`
  Returns the list of codevalue objects for the specified categoryId and codesetName.
  `List<CodeValue>`
  `getCodeValues(int categoryId, String codesetName, int fillOptions)`
  Returns the list of codevalue objects for the specified categoryId and codesetName.
  `String`
  `getCodeValuesAs(int codesetId, int fillOptions, String outputFormat)`
  Returns the list of codevalue objects for the specified codesetId.
  `String`
  `getCodeValuesAs(int codesetId, String outputFormat)`
  Returns the list of codevalue objects for the specified codesetId.
  `String`
  `getCodeValuesAs(int categoryId, String codesetName, int fillOptions, String outputFormat)`
  Returns the list of codevalue objects for the specified categoryId and codesetName.
  `String`
  `getCodeValuesAs(int categoryId, String codesetName, String outputFormat)`
  Returns the list of codevalue objects for the specified categoryId and codesetName.
  `CSMEnvironment`
  `getEnvironment(int environmentId)`
  Returns the environment object for the specified environmentId.
  `String`
  `getEnvironmentAs(int environmentId, String outputFormat)`
  Returns the environment object for the specified environmentId.
  `int`
  `getEnvironmentId(String environmentName)`
  Returns the environment id for the specified environment name.
  `String`
  `getEnvironmentIdAs(String environmentName, String outputFormat)`
  Returns the environmentId for the specified environmentName.
  `String`
  `getEnvironmentName(int environmentId)`
  Returns the environmen name for the specified environmentId.
  `String`
  `getEnvironmentNameAs(int environmentId, String outputFormat)`
  Returns the environmen name for the specified environmentId.
  `List<CSMEnvironment>`
  `getEnvironments()`
  Returns the list of environments along with all the details regarding each environment.
  `String`
  `getEnvironmentsAs(String outputFormat)`
  Returns the list of environments along with all the details regarding each environment.
  `List<CodeValue>`
  `getLogicallyDeletedCodeValues(int codesetId)`
  Returns the list of logically deleted codevalue objects for the specified codesetId.
  `String`
  `getLogicallyDeletedCodeValuesAs(int codesetId, String outputFormat)`
  Returns the list of logically deleted codevalue objects for the specified codesetId.
  `List<Codeset>`
  `getPublishedCodesets(int environmentId)`
  Returns the list of published codeset objects for the specified environmentId.
  `String`
  `getPublishedCodesetsAs(int environmentId, String outputFormat)`
  Returns the list of published codesets for the specified environmentId.
  `List<Codeset>`
  `getRetiredCodesets(int categoryId)`
  Returns the list of retired codeset objects for the specified categoryId.
  `String`
  `getRetiredCodesetsAs(int categoryId, String outputFormat)`
  Returns the list of retired codeset objects for the specified categoryId.
  `List<CodeValue>`
  `getValidValues(Node.NodeType nodeType, int nodeId)`
  Returns the list of code value objects for the specified nodeId where each code value object contains code name, code value, code description and codeset name in which code value is present etc....
  `List<CodeValue>`
  `getValidValues(Node.NodeType nodeType, int nodeId, int fillOptions)`
  Returns the list of codeValue objects for the specified nodeType and nodeId.
  `String`
  `getValidValuesAs(String nodeType, int nodeId, int fillOptions, String outputFormat)`
  Returns the list of codeValue objects for the specified nodeType and nodeId.
  `RequestStatus`
  `importCodesets(int categoryId, ImportHelper importHelper)`
  Imports the codesets on the specified categoryId.
  `String`
  `importCodesetsAs(int categoryId, String importHelper, String outputFormat)`
  Imports the codesets on the specified categoryId.
  `RequestStatus`
  `importCodeValues(int codesetId, ImportHelper importHelper)`
  Imports the codevalues on the specified codesetId.
  `String`
  `importCodeValuesAs(int codesetId, String importHelper, String outputFormat)`
  Imports the codevalues on the specified codesetId.
  `RequestStatus`
  `publishCodeset(Codeset codeset)`
  Codeset is published for the specified codeset object.
  `String`
  `publishCodesetAs(String codeset, String outputFormat)`
  Codeset is published for the specified codeset object.
  `RequestStatus`
  `publishCodesets(List<Codeset> codesets)`
  Codesets are published for the specified list of codeset objects.
  `String`
  `publishCodesetsAs(String codesets, String outputFormat)`
  Codesets are published for the specified list of codeset objects.
  `RequestStatus`
  `restoreCodeValues(List<Integer> codeValueIds)`
  Retired codevalues can be restored for the specified codeValueIds.
  `String`
  `restoreCodeValuesAs(String codeValueIds, String outputFormat)`
  Retired codevalues can be restored for the specified codeValueIds.
  `RequestStatus`
  `retireCodeset(int codesetId)`
  Codeset is retired for the given codesetId.
  `String`
  `retireCodesetAs(int codesetId, String outputFormat)`
  Codeset is retired for the given codesetId.
  `RequestStatus`
  `retireCodesets(List<Integer> codesetIds)`
  Codesets are retired for the given list of codesetIds.
  `String`
  `retireCodesetsAs(String codesetIds, String outputFormat)`
  Codesets are retired for the given list of codesetIds.
  `RequestStatus`
  `unassignExistingCodesets(Node.NodeType nodeType, int nodeId)`
  Unassigns existing codesets for the specified nodeId of nodeType.
  `String`
  `unassignExistingCodesetsAs(String nodeType, int nodeId, String outputFormat)`
  Unassigns existing codesets for the specified nodeType of nodeId.
  `RequestStatus`
  `unpublishCodeset(int codesetId)`
  Codeset is unpublished for the specified codesetId.
  `String`
  `unpublishCodesetAs(int codesetId, String outputFormat)`
  Codeset is unpublished for the specified codesetId.
  `RequestStatus`
  `unpublishCodesets(List<Integer> codesetIds)`
  Codesets are unpublished for the specified list of codesetIds.
  `String`
  `unpublishCodesetsAs(String codesetIds, String outputFormat)`
  Codesets are unpublished for the specified list of codesetIds.
  `RequestStatus`
  `updateCategories(List<Category> categories)`
  Updates the categories with the specified list of category objects.
  `String`
  `updateCategoriesAs(String categories, String outputFormat)`
  Updates the list of categories with the specified category objects.
  `RequestStatus`
  `updateCategory(Category category)`
  Updates the category with the specified category object.
  `String`
  `updateCategoryAs(String category, String outputFormat)`
  Updates the category with the specified category object.
  `RequestStatus`
  `updateCodeset(Codeset codeset)`
  Updates the codeset with the specified codeset object.
  `String`
  `updateCodesetAs(String codeset, String outputFormat)`
  Updates the codeset with the specified codeset object.
  `RequestStatus`
  `updateCodesets(List<Codeset> codesets)`
  Updates the codeset with the specified codeset objects list.
  `String`
  `updateCodesetsAs(String codesets, String outputFormat)`
  Updates the codesets with the specified codeset objects list.
  `RequestStatus`
  `updateCodeValue(CodeValue codeValue)`
  Updates codevalue for the code id specified in the codeValue object.
  `RequestStatus`
  `updateCodeValue(CodeValue codeValue, boolean updateExtendedProperties)`
  Updates codevalue for the code id specified in the codevalue object and also updates its extended properties only if updateExtendedProperties flag is true.
  `String`
  `updateCodeValueAs(String codeValueObjJson, boolean updateExtendedProperties, String outputFormat)`
  Updates codevalue for the codeId specified in the codevalue object and also updates its extended properties only if updateExtendedProperties flag is true.
  `RequestStatus`
  `updateCodeValues(List<CodeValue> codeValues)`
  Updates list of codevalues for the code id specified in the list of each codevalue object.
  `RequestStatus`
  `updateCodeValues(List<CodeValue> codeValues, boolean updateExtendedProperties)`
  Updates list of codevalues for the code id specified in the each codevalue object and also updates its corresponding extended properties only if updateExtendedProperties flag is true.
  `String`
  `updateCodeValuesAs(String codeValuesObjJsonArray, boolean updateExtendedProperties, String outputFormat)`
  Updates list of codevalues for the codeId specified in the each codevalue object and also updates its corresponding extended properties only if updateExtendedProperties flag is true.
  `RequestStatus`
  `updateEnvironment(CSMEnvironment csmEnvironment)`
  Updates the environment with the specified environment object.
  `String`
  `updateEnvironmentAs(String environment, String outputFormat)`
  Updates the environment with the specified environment object.
  `RequestStatus`
  `versionCodeset(Codeset codeset)`
  Codeset is versioned for the specified codeset object.
  `String`
  `versionCodesetAs(String codeset, String outputFormat)`
  Codeset is versioned for the specified codeset object.
  `RequestStatus`
  `versionCodesets(List<Codeset> codesets)`
  Codesets are versioned for the specified list of codeset objects.
  `String`
  `versionCodesetsAs(String codesets, String outputFormat)`
  Codesets are versioned for the specified list of codeset objects.

  ### Methods inherited from class com.ads.api.util.BaseUtil

  `getAccessToken, getAccessTokenType, getTokenType, getUserDetails, permissionDeniedMessage, permissionDeniedStatus, setAccessToken, setAccessTokenType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### updateCodeValue

    public RequestStatus updateCodeValue(CodeValue codeValue)
    Updates codevalue for the code id specified in the codeValue object. Specification of code id in the codeValue object is mandatory.
    If codevalue is updated successfully,RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValue` - CodeValue
    Returns:
      RequestStatus object.
    Since:
      8.2.1

  - ### updateCodeValues

    public RequestStatus updateCodeValues(List<CodeValue> codeValues)
    Updates list of codevalues for the code id specified in the list of each codevalue object. Specification of code id in each codevalue object is mandatory.
    If codevalues are updated successfully,RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValues` - List
    Returns:
      RequestStatus object.
    Since:
      8.2.1

  - ### updateCodeValue

    public RequestStatus updateCodeValue(CodeValue codeValue, boolean updateExtendedProperties)
    Updates codevalue for the code id specified in the codevalue object and also updates its extended properties only if updateExtendedProperties flag is true. Specification of code id in the codevalue object and updateExtendedProperties flag are mandatory.
    If codevalue is updated successfully,RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValue` - CodeValue
      `updateExtendedProperties` - boolean
    Returns:
      RequestStatus object.
    Since:
      8.2.1

  - ### updateCodeValues

    public RequestStatus updateCodeValues(List<CodeValue> codeValues, boolean updateExtendedProperties)
    Updates list of codevalues for the code id specified in the each codevalue object and also updates its corresponding extended properties only if updateExtendedProperties flag is true. Specification of codeId in the each codevalue object and updateExtendedProperties flag are mandatory.
    If codevalues are updated successfully,RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValues` - List
      `updateExtendedProperties` - boolean
    Returns:
      RequestStatus object.
    Since:
      8.2.1

  - ### updateCodeValueAs

    public String updateCodeValueAs(String codeValueObjJson, boolean updateExtendedProperties, String outputFormat)
    Updates codevalue for the codeId specified in the codevalue object and also updates its extended properties only if updateExtendedProperties flag is true. Specification of codeId in the codevalue object and updateExtendedProperties flag are mandatory.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValueObjJson` - String
      `updateExtendedProperties` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalue is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValueObjJson' JSON :
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }

    Since:
      8.2.1

  - ### updateCodeValuesAs

    public String updateCodeValuesAs(String codeValuesObjJsonArray, boolean updateExtendedProperties, String outputFormat)
    Updates list of codevalues for the codeId specified in the each codevalue object and also updates its corresponding extended properties only if updateExtendedProperties flag is true.
    Specification of codeId in the each codevalue object and updateExtendedProperties flag are mandatory.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValuesObjJsonArray` - String
      `updateExtendedProperties` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.

      Sample 'codeValuesObjJsonArray' JSON :
      [
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      },
      {
      "id": 0,
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }
      ]

    Since:
      8.2.1

  - ### createCategory

    public RequestStatus createCategory(Category category)
    Category is added for the specified category object. Specifying the category name and category type are mandatory, while creating the category. To create a sub category specifying the parent category id is mandatory.
    If category is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `category` - Category Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createCategory

    public RequestStatus createCategory(int parentCategoryId, Category.Type categoryType, String categoryName)
    Category is added for the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory, while creating the category. To create a sub category specifying the parentCategoryId is mandatory.
    If category is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `parentCategoryId` - int
      `categoryName` - String
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createCategories

    public RequestStatus createCategories(List<Category> categories)
    Categories are added for the specified list of category objects. Specification of category name and category type in each category object are mandatory. To create a sub category specifying the parent category id is mandatory.
    If categories are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categories` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### updateCategory

    public RequestStatus updateCategory(Category category)
    Updates the category with the specified category object. All the information pertaining to the category can be updated. Specifying the category id and category name are mandatory to update the category.
    If category details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `category` - Category Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### updateCategories

    public RequestStatus updateCategories(List<Category> categories)
    Updates the categories with the specified list of category objects. All the information related to the categories can be updated. Specification of category id and category name in each category object is mandatory to update the categories.
    If categories details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categories` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCategory

    public RequestStatus deleteCategory(int categoryId, Category.Type categoryType)
    Deletes the category with the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory to delete a particular category.
    If the category is deleted all its associated data will also be deleted.
    If category is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCategory

    public RequestStatus deleteCategory(Category category)
    Deletes the category with the specified category object. Specifying the categoryId and categoryType are mandatory to delete a particular category.
    If the category is deleted all its associated data will also be deleted.
    If category is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `category` - Category object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCategory

    public RequestStatus deleteCategory(int parentCategoryId, Category.Type categoryType, String categoryName)
    Deletes the category with the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory to delete a particular category. To delete a sub category specifying the parentCategoryId is mandatory.
    If the category is deleted all its associated data will also be deleted.
    If category is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `parentCategoryId` - int
      `categoryName` - String
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCategories

    public RequestStatus deleteCategories(List<Integer> categoryIds, Category.Type categoryType)
    Deletes the categories with the specified list of categoryIds and categoryType. Specifying the categoryIds list and categoryType are mandatory.
    If the categories are deleted all its associated data will also be deleted.
    If categories are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### getCategory

    public Category getCategory(int categoryId, Category.Type categoryType) throws Exception
    Returns the category object for the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory.
    It returns all the details like category name, description, category type, parentCategoryId, and auditHistory details etc..
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryId` - int
    Returns:
      String - Category object in the form of JSON String.
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategory

    public Category getCategory(int categoryId, Category.Type categoryType, int fillOptions) throws Exception
    Returns the category object for the specified categoryId and categoryType. Specifying the categoryId, categoryType are mandatory. If you want to return the category object filled with codeset and codevalues specifying the value of fillOption is needed.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      String - Category object in the form of JSON String.
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategory

    public Category getCategory(int parentCategoryId, Category.Type categoryType, String categoryName) throws Exception
    Returns the category object for the specified parentCategoryId, categoryType and categoryName. Specifying the parentCategoryId, categoryType and categoryName are mandatory.
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `parentCategoryId` - int
      `categoryName` - String
    Returns:
      String - Category object in the form of JSON String.
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategories

    public List<Category> getCategories(List<Integer> categoryIds, Category.Type categoryType, int fillOptions) throws Exception
    Returns the list of category objects for the specified categoryIds list and categoryType. Specifying the categoryIds list and categoryType are mandatory.If you want to return the category object filled with codeset and codevalues specifying the value of fillOption is needed.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    Parameters:
      `categoryType` - String Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryIds` - List
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List of category objects in the form of JSON String
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategories

    public List<Category> getCategories(List<Integer> categoryIds, Category.Type categoryType) throws Exception
    Returns the list of category objects for the specified categoryIds list and categoryType. Specifying the categoryIds list and categoryType are mandatory.
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    Parameters:
      `categoryIds` - List
      `categoryType` - String Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
    Returns:
      List of category objects in the form of JSON String
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategoryId

    public int getCategoryId(int parentCategoryId, Category.Type categoryType, String categoryName) throws Exception
    Returns the category id for the given categoryName and categoryType. Specifying the categoryName and categoryType are mandatory. In order to return the sub category id specifying the parentCategoryId is mandatory.
    It returns the categoryId
    Parameters:
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS.
      `parentCategoryId` - int
      `categoryName` - String
    Returns:
      categoryId int
    Throws:
      `Exception`
    Since:
      12.0

  - ### createCodeset

    public RequestStatus createCodeset(Codeset codeset, boolean saveCodeValues)
    Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true. Specifying the codeset name, category id and saveCodeValues flag are mandatory, while creating the codeset.
    If codeset is created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeset` - Codeset Object
      `saveCodeValues` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createCodeset

    public RequestStatus createCodeset(int categoryId, Codeset codeset, boolean saveCodeValues)
    Codeset is added for the specified categoryId, codeset object and also code values are added only if the saveCodeValues flag is true. Specifying the codeset name, category id and saveCodeValues flag are mandatory, while creating the code set.
    If codeset is created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryId` - int
      `codeset` - CodeSet Object
      `saveCodeValues` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createCodesets

    public RequestStatus createCodesets(List<Codeset> codesets, boolean saveCodeValues)
    Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true. Specification of codeset name, category id in each codeset object and saveCodeValues flag are mandatory.
    If codesets are created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesets` - List
      `saveCodeValues` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createCodesets

    public RequestStatus createCodesets(int categoryId, List<Codeset> codesets, boolean saveCodeValues)
    Codesets are added for the specified list of codeset objects and also code values are added only if the saveCodeValues flag is true. Specification of codeset name, category id in each codeset object and saveCodeValues flag are mandatory.
    If codesets are created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryId` - int
      `codesets` - List of codeset objects
      `saveCodeValues` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### updateCodeset

    public RequestStatus updateCodeset(Codeset codeset)
    Updates the codeset with the specified codeset object. All the information related to the codeset can be updated. Specifying the codeset id, codeset name and category id are mandatory to update the codeset.
    If codeset details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeset` - Codeset Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### updateCodesets

    public RequestStatus updateCodesets(List<Codeset> codesets)
    Updates the codeset with the specified codeset objects list. All the information related to the codesets can be updated. Specification of codeset id, codeset name and category id in each codeset object are mandatory to update the codesets.
    If codesets details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesets` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeset

    public RequestStatus deleteCodeset(int codesetId)
    Deletes the codeset with the specified codesetId.Specifying the codesetId is mandatory to delete a particular codeset.
    If the codeset is deleted all its associated data will also be deleted.
    If codeset is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeset

    public RequestStatus deleteCodeset(Codeset codeset)
    Deletes the codeset with the specified codeset object. Specifying the codesetId is mandatory to delete a particular code set.
    If the codeset is deleted all its associated data will also be deleted.
    If codeset is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeset` - CodeSet object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeset

    public RequestStatus deleteCodeset(int codesetId, APIConstants.VersionMode versionMode)
    Deletes the codeset with the specified codesetId and versionMode. Specifying the codesetId is mandatory to delete a particular codeset. If versionMode is not specified current version codeset will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codeset is deleted all its associated data will also be deleted.
    If codeset is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
      `versionMode` - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodesets

    public RequestStatus deleteCodesets(List<Integer> codesetIds)
    Deletes the codesets with the specified list of codesetIds. Specifying the codesetIds list is mandatory. All current version codesets will be deleted.
    If codesets are deleted all its associated data will also be deleted.
    If codesets are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodesets

    public RequestStatus deleteCodesets(List<Integer> codesetIds, APIConstants.VersionMode versionMode)
    Deletes the codeset with the specified codesetIds list and versionMode. Specifying the codesetIds list is mandatory. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If codesets are deleted all its associated data will also be deleted.
    If codesets are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetIds` - List
      `versionMode` - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodesets

    public RequestStatus deleteCodesets(int categoryId)
    Deletes the list of codesets for the given categoryId. Specifying the categoryId is mandatory to delete codesets.
    If the codesets are deleted all its associated data will also be deleted.
    If codesets are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodesets

    public RequestStatus deleteCodesets(int categoryId, APIConstants.VersionMode versionMode)
    Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    If codesets are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryId` - int
      `versionMode` - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodesets

    public RequestStatus deleteCodesets(int categoryId, List<String> codesetNames, APIConstants.VersionMode versionMode)
    Deletes the list of codesets for the specified categoryId, codesetNames list and versionMode. Specifying the categoryId and codesetNames list are mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    If codesets are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `categoryId` - int
      `codesetNames` - List
      `versionMode` - - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int codesetId) throws Exception
    Returns the codeset object for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `codesetId` - int
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int codesetId, int fillOptions) throws Exception
    Returns the codeset object for the specified codesetId. Specifying the codesetId is mandatory. If you want to return the codeset object with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int categoryId, String codesetName) throws Exception
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. Only active version codesets will be returned in this method
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `codesetName` - String
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int categoryId, String codesetName, int fillOptions) throws Exception
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. If you want to return the codeset object with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int categoryId, String codesetName, float version) throws Exception
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. Active/Passive codesets based on version will be returned in this method
    It returns all the details like codeset name, description, categoryId, and auditHistory details.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `version` - float
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeset

    public Codeset getCodeset(int categoryId, String codesetName, float version, int fillOptions) throws Exception
    Returns the codeset object for the specified categoryId, codesetName and version. Specifying the categoryId, codesetName and version are mandatory. Active/Passive codeset based on version will be returned in this method. If you want to return the codeset object filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `version` - float
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      Codeset Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodesetId

    public int getCodesetId(int categoryId, String codesetName) throws Exception
    Returns the codeset id for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Only active version codeset id will be returned in this method.
    It returns codeset id.
    Parameters:
      `categoryId` - int
      `codesetName` - String
    Returns:
      codesetId int
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodesets

    public List<Codeset> getCodesets(int categoryId) throws Exception
    Returns the list of codeset objects for the specified categoryId. Specifying the categoryId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
    Returns:
      List of Codesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodesets

    public List<Codeset> getCodesets(int categoryId, int fillOptions) throws Exception
    Returns the list of codeset objects for the specified categoryId. Specifying the categoryId is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List of Codesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodesets

    public List<Codeset> getCodesets(List<Integer> codesetIds) throws Exception
    Returns the list of codeset objects for the specified codesetIds list. Specifying the codesetIds list is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `codesetIds` - List
    Returns:
      List of Codesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodesets

    public List<Codeset> getCodesets(List<Integer> codesetIds, int fillOptions) throws Exception
    Returns the list of codeset objects for the specified codesetIds list. Specifying the codesetIds list is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `codesetIds` - List
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List of Codesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getPublishedCodesets

    public List<Codeset> getPublishedCodesets(int environmentId) throws Exception
    Returns the list of published codeset objects for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `environmentId` - int
    Returns:
      List of PublishedCodesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getRetiredCodesets

    public List<Codeset> getRetiredCodesets(int categoryId) throws Exception
    Returns the list of retired codeset objects for the specified categoryId. Specifying the categoryId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
    Returns:
      List of RetiredCodesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### getAllRetiredCodesets

    public List<Codeset> getAllRetiredCodesets() throws Exception
    Returns the list of all retired codesets present in enterprise codesets.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    Returns:
      List of RetiredCodesets
    Throws:
      `Exception`
    Since:
      12.0

  - ### publishCodeset

    public RequestStatus publishCodeset(Codeset codeset)
    Codeset is published for the specified codeset object. Specifying the codeset id, change description and publish environments list are mandatory to publish codeset.
    If codeset is published successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeset` - Codeset Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### publishCodesets

    public RequestStatus publishCodesets(List<Codeset> codesets)
    Codesets are published for the specified list of codeset objects. Specification of codeset id, change description and publish environments list in each codeset object are mandatory.
    If codeset are published successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesets` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### unpublishCodeset

    public RequestStatus unpublishCodeset(int codesetId)
    Codeset is unpublished for the specified codesetId. Specifying the codesetId is mandatory to unpublish codeset.
    If codeset is unpublished successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### unpublishCodesets

    public RequestStatus unpublishCodesets(List<Integer> codesetIds)
    Codesets are unpublished for the specified list of codesetIds. Specifying the list of codesetIds is mandatory to unpublish codesets.
    If codesets are unpublished successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### retireCodeset

    public RequestStatus retireCodeset(int codesetId)
    Codeset is retired for the given codesetId. Specifying the codesetId is mandatory. Retired codesets cannot be restored.
    If codeset is retired successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### retireCodesets

    public RequestStatus retireCodesets(List<Integer> codesetIds)
    Codesets are retired for the given list of codesetIds. specifying the list of codesetIds is mandatory. Retired codesets cannot be restored.
    If codesets are retired successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### versionCodeset

    public RequestStatus versionCodeset(Codeset codeset)
    Codeset is versioned for the specified codeset object. Creates a copy of entire codeset with new codeset Id and passive state. Specifying the codeset id, change description are mandatory to version the codeset.
    If codeset is versioned successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeset` - Codeset Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### versionCodesets

    public RequestStatus versionCodesets(List<Codeset> codesets)
    Codesets are versioned for the specified list of codeset objects. Specifying the codeset id, change description are mandatory to version the codesets.
    If codesets are versioned successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesets` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### cloneCodeset

    public RequestStatus cloneCodeset(int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists)
    Codeset is cloned for the given srcCodesetId to the given tgtCategoryId. Specifying the srcCodesetId and tgtCategoryId are mandatory to clone the codeset.
    If codeset is cloned successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `srcCodesetId` - int
      `createNewVersionIfExists` - boolean
      `tgtCategoryId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createEnvironment

    public RequestStatus createEnvironment(CSMEnvironment csmEnvironment)
    CSMEnvironment is added for the specified environment object. Specifying the environment name is mandatory, while creating the environment.
    If environment is created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `csmEnvironment` - CSMEnvironment Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### createEnvironments

    public RequestStatus createEnvironments(List<CSMEnvironment> csmEnvironments)
    List of environments are added for the specified list of environment objects. Specifying the environment name is mandatory, while creating the environments.
    If environments are created successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `csmEnvironments` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### updateEnvironment

    public RequestStatus updateEnvironment(CSMEnvironment csmEnvironment)
    Updates the environment with the specified environment object. All the information pertaining to the environment can be updated. Specifying the environment id is mandatory to update the environment.
    If environment details are updated successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `csmEnvironment` - CSMEnvironment Object
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### getEnvironmentId

    public int getEnvironmentId(String environmentName) throws Exception
    Returns the environment id for the specified environment name. Specifying the environment name is mandatory.
    It returns the environment id
    Parameters:
      `environmentName` - String
    Returns:
      environmentId int
    Throws:
      `Exception`
    Since:
      12.0

  - ### getEnvironmentName

    public String getEnvironmentName(int environmentId) throws Exception
    Returns the environmen name for the specified environmentId. Specifying the environmentId is mandatory.
    It returns the environment name
    Parameters:
      `environmentId` - int
    Returns:
      EnvironmentName String
    Throws:
      `Exception`
    Since:
      12.0

  - ### getEnvironment

    public CSMEnvironment getEnvironment(int environmentId) throws Exception
    Returns the environment object for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like environment name, description, auditHistory details etc..
    Parameters:
      `environmentId` - int
    Returns:
      CSMEnvironment Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### getEnvironments

    public List<CSMEnvironment> getEnvironments() throws Exception
    Returns the list of environments along with all the details regarding each environment.
    Returns all the available environments as a list of environment object.
    Returns:
      List of Environments
    Throws:
      `Exception`
    Since:
      12.0

  - ### deleteEnvironment

    public RequestStatus deleteEnvironment(int environmentId)
    Deletes the environment with the specified environmentId. Specifying the environmentId is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted.
    If environment is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `environmentId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteEnvironment

    public RequestStatus deleteEnvironment(CSMEnvironment csmEnvironment)
    Deletes the environment with the specified environmen object. Specifying the environmentId is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted.
    If environment is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `csmEnvironment` -
    Returns:
    Since:
      12.0

  - ### deleteEnvironment

    public RequestStatus deleteEnvironment(String environmentName)
    Deletes the environment with the specified environmentName. Specifying the environmentName is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted.
    If environment is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `environmentName` - String
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteEnvironments

    public RequestStatus deleteEnvironments(List<Integer> environmentIds)
    Deletes the environments with the specified list of environmentIds. Specifying the environmentIds list is mandatory.
    If the environments are deleted all its associated data will also be deleted.
    If environments are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `environmentIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### addCodeValue

    public RequestStatus addCodeValue(CodeValue codeValue, boolean saveExtendedProperties)
    Codevalue is added for the specified codevalue object and also extended properties are added only if the saveExtendedProperties flag is true. Specifying the codeset id, code name, value and saveExtendedProperties flag are mandatory, while creating the codevalue.
    If codevalue is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValue` - CodeValue Object
      `saveExtendedProperties` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### addCodeValue

    public RequestStatus addCodeValue(int codesetId, CodeValue codeValue, boolean saveExtendedProperties)
    Codevalue is added for the specified codesetId, codevalue object and also extended properties are added only if the saveExtendedProperties flag is true. Specifying the codeset id, code name, value and saveExtendedProperties flag are mandatory, while adding the codevalue.
    If codevalue is added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
      `codeValue` - CodeValue
      `saveExtendedProperties` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### addCodeValues

    public RequestStatus addCodeValues(List<CodeValue> codeValues, boolean saveExtendedProperties)
    Codevalues are added for the specified list of codevalue objects and also extended properties are added only if the saveExtendedProperties flag is true. Specification of codeset id, code name, value in each codevalue object and saveExtendedProperties flag are mandatory.
    If codevalues are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValues` - List
      `saveExtendedProperties` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### addCodeValues

    public RequestStatus addCodeValues(int codesetId, List<CodeValue> codeValues, boolean saveExtendedProperties)
    Codevalues are added for the specified codesetId list of codevalue objects and also extended properties are added only if the saveExtendedProperties flag is true. Specification of codeset id, code name, value in each codevalue object and saveExtendedProperties flag are mandatory.
    If codevalues are added successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
      `codeValues` - List of CodeValue objects
      `saveExtendedProperties` - boolean
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### getCodeValues

    public List<CodeValue> getCodeValues(int categoryId, String codesetName) throws Exception
    Returns the list of codevalue objects for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `codesetName` - String
    Returns:
      List of Codevalue Objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeValues

    public List<CodeValue> getCodeValues(int categoryId, String codesetName, int fillOptions) throws Exception
    Returns the list of codevalue objects for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If odeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List of codevalue objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeValues

    public List<CodeValue> getCodeValues(int codesetId) throws Exception
    Returns the list of codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc
    Parameters:
      `codesetId` - int
    Returns:
      List of codevalue objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCodeValues

    public List<CodeValue> getCodeValues(int codesetId, int fillOptions) throws Exception
    Returns the list of codevalue objects for the specified codesetId. Specifying the codesetId is mandatory. Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If codeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    Parameters:
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List of codevalue objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getLogicallyDeletedCodeValues

    public List<CodeValue> getLogicallyDeletedCodeValues(int codesetId) throws Exception
    Returns the list of logically deleted codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    Parameters:
      `codesetId` - int
    Returns:
      List of LogicallyDeletedCodeValues
    Throws:
      `Exception`
    Since:
      12.0

  - ### restoreCodeValues

    public RequestStatus restoreCodeValues(List<Integer> codeValueIds)
    Retired codevalues can be restored for the specified codeValueIds. Specifying the codeValueIds list is mandatory.
    Parameters:
      `codeValueIds` - List
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeValue

    public RequestStatus deleteCodeValue(int codeValueId, APIConstants.DeleteMode deleteMode)
    Deletes the code value with the specified codeValueId and deleteMode. Specifying the codeValueId is mandatory to delete a particular codeValue. If deleteMode is not specified the code value object will be purge deleted. The retired code values can be restored.
    Delete mode has values RETIRE and PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If the codeValue is deleted all its associated data will also be deleted.
    If code value is deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValueId` - int
      `deleteMode` - DeleteMode type - Valid values are RETIRE/PURGE.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeValues

    public RequestStatus deleteCodeValues(List<Integer> codeValueIds, APIConstants.DeleteMode deleteMode)
    Deletes the list of code value objects with the specified codeValueIds list and deleteMode. Specifying the codeValueIds list is mandatory to delete code values. If deleteMode is not specified the code value objects will be purge deleted. The retired code values can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If the code values are deleted all its associated data will also be deleted.
    If code values are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codeValueIds` - List
      `deleteMode` - DeleteMode type - Valid values are RETIRE/PURGE.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### deleteCodeValues

    public RequestStatus deleteCodeValues(int codesetId, APIConstants.DeleteMode deleteMode) throws Exception
    Deletes the list of codevalue objects with the specified codesetId and deleteMode. Specifying the codesetId is mandatory to delete codevalues. If deleteMode is not specified the codevalue object will be purge deleted. The retired code values can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If the codevalues are deleted all its associated data will also be deleted.
    If codevalues are deleted successfully, RequestStatus.isRequestSuccess() will return true otherwise false.
    Parameters:
      `codesetId` - int
      `deleteMode` - DeleteMode type - Valid values are RETIRE/PURGE.
    Returns:
      RequestStatus Object
    Throws:
      `Exception`
    Since:
      12.0

  - ### importCodesets

    public RequestStatus importCodesets(int categoryId, ImportHelper importHelper)
    Imports the codesets on the specified categoryId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the categoryId is mandatory.
    Parameters:
      `categoryId` - int
      `importHelper` - ImportHelper
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### importCodeValues

    public RequestStatus importCodeValues(int codesetId, ImportHelper importHelper)
    Imports the codevalues on the specified codesetId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the codesetId is mandatory.
    Parameters:
      `codesetId` - int
      `importHelper` - ImportHelper
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### exportCodeValues

    public RequestStatus exportCodeValues(int codesetId)
    Codevalues are exported to excel for the specified codesetId. Specifying the codesetId is mandatory.
    All the codevalues of the specified codesetId are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE.
    Parameters:
      `codesetId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### exportCodesets

    public RequestStatus exportCodesets(int categoryId, boolean includeSubCategories)
    Codesets are exported to excel for the specified categoryId. All the codesets of the specified categoryId are exported to excel, and sub category codesets are included only if the includeSubCategories flag is true. Specifying the categoryId is mandatory.
    The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE. Specifying the categoryId and includeSubCategories flag are mandatory.
    Parameters:
      `categoryId` - int
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### exportAll

    public RequestStatus exportAll()
    All the codesets present in enterprise codesets are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE.
    Returns:
      RequestStatus Object
    Since:
      12.0

  - ### assignCodeset

    public RequestStatus assignCodeset(Node.NodeType nodeType, int nodeId, Codeset codeset)
    Assigns the specified codeset object to the specified nodeType and nodeId. Specifying the codeset object having codesetId, nodeType and nodeId are are mandatory.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId. If the codeset is assigned successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
      `codeset` - Codeset
    Returns:
      RequestStatus object
    Since:
      12.0

  - ### assignCodesets

    public RequestStatus assignCodesets(Node.NodeType nodeType, int nodeId, List<Codeset> codesets)
    Assigns the specified list of codesets to the specified nodeType and nodeId. Specifying the nodeType, nodeId and list of codesets having codesetId are mandatory.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId. If the codesets are assigned successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
      `codesets` - List of Codeset objects
    Returns:
      RequestStatus object
    Since:
      12.0

  - ### assignCodesets

    public RequestStatus assignCodesets(Node.NodeType nodeType, int nodeId, List<Integer> codesetIds, boolean unassignExisting)
    Assigns codesets of specified codeset ids to the specified nodeType and nodeId. Specifying the nodeType, nodeId, list of codeset ids and unassignExisting flag are mandatory.
    UnassignExisting flag can be either true or false. If it is true then existing codesets of specified nodeId are unassigned if any and the new codesets are assigned. If it is false then the new codesets are assigned without unassiging existing codesets of nodeId.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId. If the codeSetIds are assigned successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
      `codesetIds` - List
      `unassignExisting` - boolean
    Returns:
      RequestStatus object
    Since:
      12.0

  - ### unassignExistingCodesets

    public RequestStatus unassignExistingCodesets(Node.NodeType nodeType, int nodeId)
    Unassigns existing codesets for the specified nodeId of nodeType. Specifying the nodeType and nodeId are mandatory.
    Specification of nodeId and nodeType are mandatory, based on these it unassigns the existing codesets of a node.
    NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId. If the codeSets are unassigned successfully, RequestStatus.isRequestSuccess() returns true otherwise returns false.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
    Returns:
      RequestStatus object
    Since:
      12.0

  - ### getAssignedCodesets

    public List<Codeset> getAssignedCodesets(Node.NodeType nodeType, int nodeId) throws Exception
    Returns the list of codeset objects for the specified nodeType and nodeId where each codeset object contains codeset name, codeset description, codeset status and category name in which codeset is present etc...
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
    Returns:
      List - Codeset Objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getAssignedCodesets

    public List<Codeset> getAssignedCodesets(Node.NodeType nodeType, int nodeId, int fillOptions) throws Exception
    Returns the list of codeset objects for the specified nodeType and nodeId. The returned codeset objects contains all the details pertaining to codeset such as codeset name, codeset description, codeset status and category name in which codeset is present etc.. and also contains details of codeValue and codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.SMFillOptions`.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeValues and codeValue extended properties then fillOptions parameter value will be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2=3 and so on.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
    Returns:
      List - Codeset Objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getValidValues

    public List<CodeValue> getValidValues(Node.NodeType nodeType, int nodeId) throws Exception
    Returns the list of code value objects for the specified nodeId where each code value object contains code name, code value, code description and codeset name in which code value is present etc....
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
    Returns:
      List - CodeValue objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### getValidValues

    public List<CodeValue> getValidValues(Node.NodeType nodeType, int nodeId, int fillOptions) throws Exception
    Returns the list of codeValue objects for the specified nodeType and nodeId. The returned codeValue objects contains all the details pertaining to codeValue such as code name, code value, code description, codeset name in which codeValue is present etc..and also contains details of codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` whose value is 2. If fillOptions parameter value is passed as 64 then codeValue's extended properties are returned within the CodeValue object. If CodeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    Parameters:
      `nodeType` - Node
      `nodeId` - int
      `fillOptions` - `APIConstants.SMFillOptions` int
    Returns:
      List of CodeValue Objects
    Throws:
      `Exception`
    Since:
      12.0

  - ### createCategoryAs

    public String createCategoryAs(String category, String outputFormat)
    Category is added for the specified category object. Specifying the category name and category type are mandatory, while creating the category. To create a sub category specifying the parent category id is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `category` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If category is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Category' JSON :
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }

    Since:
      12.0

  - ### createCategoryAs

    public String createCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)
    Category is added for the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory, while creating the category. To create a sub category specifying the parentCategoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If category is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### createCategoriesAs

    public String createCategoriesAs(String categories, String outputFormat)
    Categories are added for the specified list of category objects. Specification of category name and category type in each category object is mandatory while creating the category. To create a sub category specifying the parent category id is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categories` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If categories are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Categories' JsonArray :
      [
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      },
      {
      "categoryType": "",
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }
      ]

    Since:
      12.0

  - ### updateCategoryAs

    public String updateCategoryAs(String category, String outputFormat)
    Updates the category with the specified category object. All the information about the category can be updated. Specifying the category id and category name are mandatory to update the category.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `category` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If category is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Category' JSON :
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }

    Since:
      12.0

  - ### updateCategoriesAs

    public String updateCategoriesAs(String categories, String outputFormat)
    Updates the list of categories with the specified category objects. All the information about the categories can be updated. Specification of category id and category name in each category object is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categories` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If categories are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Categories' JsonArray :
      [
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      },
      {
      "categoryType": "",
      "id": 0,
      "name": "",
      "parentId": 0,
      "description": "",
      "auditHistory": null,
      "categories": [],
      "codesets": []
      }
      ]

    Since:
      12.0

  - ### deleteCategoryAs

    public String deleteCategoryAs(int categoryId, String categoryType, String outputFormat)
    Deletes the category with the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory to delete a particular category.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If category is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCategoryAs

    public String deleteCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)
    Deletes the category with the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory to delete a particular category. To delete a sub category specifying the parentCategoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If category is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCategoriesAs

    public String deleteCategoriesAs(String categoryIds, String categoryType, String outputFormat)
    Deletes the categories with the specified list of categoryIds and categoryType. Specifying the categoryIds list and categoryType are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryIds` - String
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If categories are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategoryAs

    public String getCategoryAs(int categoryId, String categoryType, String outputFormat)
    Returns the category object for the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory.
    It returns all the details like category name, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Category object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategoryAs

    public String getCategoryAs(int categoryId, String categoryType, int fillOptions, String outputFormat)
    Returns the category object for the specified categoryId and categoryType. Specifying the categoryId and categoryType are mandatory. If you want to return the category object filled with codeset and codevalues specifying the value of fillOptions is needed.
    `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `categoryType` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Category object in the form of JSON String.
    Since:
      12.0

  - ### getCategoryAs

    public String getCategoryAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)
    Returns the category object for the specified parentCategoryId, categoryType and categoryName. Specifying the parentCategoryId, categoryType and categoryName are mandatory.
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Category object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCategoriesAs

    public String getCategoriesAs(String categoryIds, String categoryType, int fillOptions, String outputFormat) throws Exception
    Returns the list of category objects for the specified categoryIds list and categoryType.Specifying the categoryIds list and categoryType are mandatory. If you want to return the category object filled with codeset and codevalues specifying the value of fillOptions is needed.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_SETS` or `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the category object and if you want to get category with codesets and codevalues then fillOptions parameter value will be be addition of CODE_SETS value and CODE_VALUES value i.e 4+1 = 5 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like category name, category type, description, parentCategoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryIds` - String
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Category objects in the form of JSON or XML String
    Throws:
      `Exception`
    Since:
      12.0

  - ### getCategoryIdAs

    public String getCategoryIdAs(int parentCategoryId, String categoryType, String categoryName, String outputFormat)
    Returns the category id for the specified categoryName and categoryType. Specifying the categoryName and categoryType are mandatory.
    It returns the category id.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `parentCategoryId` - int
      `categoryType` - String - Valid values are - ENTERPRISE_CODESETS/CODESET_MAPPINGS
      `categoryName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - categoryId in the form of JSON or XML String.
    Since:
      12.0

  - ### createCodesetAs

    public String createCodesetAs(String codeset, boolean saveCodeValues, String outputFormat)
    Codeset is added for the specified codeset object and also codevalues are added only if the saveCodeValues flag is true. Specifying the codeset name, category id and saveCodeValues flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeset` - String
      `saveCodeValues` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }

    Since:
      12.0

  - ### createCodesetsAs

    public String createCodesetsAs(String codesets, boolean saveCodeValues, String outputFormat)
    Codesets are added for the specified list of codeset objects and also codevalues are added only if the saveCodeValues flag is true. Specification of codeset name and category id in each codeset object and saveCodeValues flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesets` - String
      `saveCodeValues` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      },
      {
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### updateCodesetAs

    public String updateCodesetAs(String codeset, String outputFormat)
    Updates the codeset with the specified codeset object. All the information about the codeset can be updated. Specifying the codeset id, codeset name and category id are mandatory to update the codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeset` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }

    Since:
      12.0

  - ### updateCodesetsAs

    public String updateCodesetsAs(String codesets, String outputFormat)
    Updates the codesets with the specified codeset objects list. All the information related to the codesets can be updated. Specification of the codeset id, codeset name, and category id in each codeset object are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesets` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": false,
      "locked": false,
      "lockedBy": "",
      "environments": [],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### deleteCodesetAs

    public String deleteCodesetAs(int codesetId, String outputFormat)
    Deletes the codeset with the specified codesetId.Specifying the codesetId is mandatory to delete a particular codeset.
    If the codeset is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetAs

    public String deleteCodesetAs(int codesetId, String versionMode, String outputFormat)
    Deletes the codeset with the specified codesetId and versionMode. Specifying the codesetId is mandatory to delete particular codeset. If versionMode is not specified current version codeset will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codeset is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetsAs

    public String deleteCodesetsAs(String codesetIds, String outputFormat)
    Deletes the codesets with the specified list of codesetIds. Specifying the codesetIds list is mandatory. .
    If codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetsAs

    public String deleteCodesetsAs(String codesetIds, String versionMode, String outputFormat)
    Deletes the codesets with the specified codesetIds list and versionMode. Specifying the codesetIds list is mandatory. if versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `versionMode` - VersionMode type - Valid values are ALL_VERSIONS/CURRENT_VERSION.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetsAs

    public String deleteCodesetsAs(int categoryId, String outputFormat)
    Deletes the list of codesets for the given categoryId. Specifying the categoryId is mandatory to delete codesets.
    If the codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetsAs

    public String deleteCodesetsAs(int categoryId, String versionMode, String outputFormat)
    Deletes the list of codesets for the specified categoryId and versionMode Specifying the categoryId is mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodesetsAs

    public String deleteCodesetsAs(int categoryId, String codesetNames, String versionMode, String outputFormat)
    Deletes the list of codesets for the specified categoryId, codesetNames and versionMode. Specifying the categoryId, codesetNames list are mandatory to delete codesets. If versionMode is not specified all current version codesets will be deleted.
    Version mode has values ALL_VERSIONS, CURRENT_VERSION.
    ALL_VERSIONS - Deletes all codesets.
    CURRENT_VERSION - Deletes the present/current version.
    If the codesets are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetNames` - String
      `versionMode` - String - Valid values are ALL_VERSIONS/CURRENT_VERSION.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int codesetId, String outputFormat)
    Returns the codeset object for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int codesetId, int fillOptions, String outputFormat)
    Returns the codeset object for the specified codesetId. Specifying the codesetId is mandatory. If you want to return the codeset object filled with codevalues and its extended properties specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int categoryId, String codesetName, String outputFormat)
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int categoryId, String codesetName, int fillOptions, String outputFormat)
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. If you want to return the codeset object filled with codevalues and its extended properties specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int categoryId, String codesetName, float version, String outputFormat)
    Returns the codeset object for the specified categoryId, codesetName and version. Specifying the categoryId and codesetName are mandatory. Active/Passive codeset based on version will be returned in this method.
    It returns all the details like codeset name, description, categoryId, and auditHistory details.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `version` - float
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON String.
    Since:
      12.0

  - ### getCodesetAs

    public String getCodesetAs(int categoryId, String codesetName, float version, int fillOptions, String outputFormat)
    Returns the codeset object for the specified categoryId and codesetName Specifying the categoryId and codesetName are mandatory. Active/Passive codesets based on version will be returned in this method. If you want to return the codeset object filled with codevalues and its extended properties specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `version` - float
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - Codeset object in the form of JSON String.
    Since:
      12.0

  - ### getCodesetIdAs

    public String getCodesetIdAs(int categoryId, String codesetName, String outputFormat)
    Returns the codeset id for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Only active version codeset id will be returned in this method.
    It returns codeset id.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - codeset id in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodesetsAs

    public String getCodesetsAs(int categoryId, String outputFormat)
    Returns the list of codeset objects for the specified categoryId. Specifying the categoryId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Codeset objects in the form of JSON String
    Since:
      12.0

  - ### getCodesetsAs

    public String getCodesetsAs(int categoryId, int fillOptions, String outputFormat)
    Returns the list of codeset objects for the specified categoryId. Specifying the categoryId is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeset with codevalues and its extended properties then fillOptions parameter value will be be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2 = 3 and so on. The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Codeset objects in the form of JSON String
    Since:
      12.0

  - ### getCodesetsAs

    public String getCodesetsAs(String codesetIds, String outputFormat)
    Returns the list of codeset objects for the specified codesetIds list. Specifying the codesetIds list is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Codeset objects in the form of JSON String
    Since:
      12.0

  - ### getCodesetsAs

    public String getCodesetsAs(String codesetIds, int fillOptions, String outputFormat)
    Returns the list of codeset objects for the specified codesetIds list. Specifying the codesetIds list is mandatory. If you want to return the codeset objects filled with codevalues specifying the value of fillOptions is mandatory.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUES` The default integer value for fillOptions is 0(zero).
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of Codeset objects in the form of JSON or XML String
    Since:
      12.0

  - ### getPublishedCodesetsAs

    public String getPublishedCodesetsAs(int environmentId, String outputFormat)
    Returns the list of published codesets for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of published codeset objects in the form of JSON or XML String
    Since:
      12.0

  - ### getRetiredCodesetsAs

    public String getRetiredCodesetsAs(int categoryId, String outputFormat)
    Returns the list of retired codeset objects for the specified categoryId. Specifying the categoryId is mandatory.
    It returns all the details like codeset name, description, categoryId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of retired codeset objects in the form of JSON or XML String
    Since:
      12.0

  - ### publishCodesetAs

    public String publishCodesetAs(String codeset, String outputFormat)
    Codeset is published for the specified codeset object. Specifying the codeset id, change description, and publish environments list are mandatory to publish codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeset` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is published successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }

    Since:
      12.0

  - ### publishCodesetsAs

    public String publishCodesetsAs(String codesets, String outputFormat)
    Codesets are published for the specified list of codeset objects. Specification of codeset id, change description and publish environments list in each codeset object are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesets` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are published successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### unpublishCodesetAs

    public String unpublishCodesetAs(int codesetId, String outputFormat)
    Codeset is unpublished for the specified codesetId. Specifying the codesetId is mandatory to unpublish codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is unpublished successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### unpublishCodesetsAs

    public String unpublishCodesetsAs(String codesetIds, String outputFormat)
    Codesets are unpublished for the specified list of codesetIds. Specifying the list of codesetIds is mandatory to unpublish codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are unpublished successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### retireCodesetAs

    public String retireCodesetAs(int codesetId, String outputFormat)
    Codeset is retired for the given codesetId. Specifying the codesetId is mandatory. Retired codesets cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is retired successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### retireCodesetsAs

    public String retireCodesetsAs(String codesetIds, String outputFormat)
    Codesets are retired for the given list of codesetIds. specifying the list of codesetIds is mandatory. Retired codesets cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are retired successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### versionCodesetAs

    public String versionCodesetAs(String codeset, String outputFormat)
    Codeset is versioned for the specified codeset object. Creates a copy of entire codeset with new codeset id and passive state. Specifying the codeset id, change description are mandatory to version the codeset .
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeset` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is versioned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codeset' JSON :
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }

    Since:
      12.0

  - ### versionCodesetsAs

    public String versionCodesetsAs(String codesets, String outputFormat)
    Codesets are versioned for the specified list of codeset objects. Specification of codeset Id, change description in each codeset object are mandatory to version the codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesets` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are versioned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Codesets' JsonArray :
      [
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      },
      {
      "id":0,
      "categoryId": 0,
      "name": "",
      "description": "",
      "auditHistory": null,
      "status": "ACTIVE",
      "version": "",
      "versionLabel": "",
      "changedDescription": "",
      "published": "",
      "locked": "",
      "lockedBy": "",
      "environments": [ {
      "id": 0,
      "name": "" }
      ],
      "codeValues": []
      }
      ]

    Since:
      12.0

  - ### cloneCodesetAs

    public String cloneCodesetAs(int srcCodesetId, int tgtCategoryId, boolean createNewVersionIfExists, String outputFormat)
    Codeset is cloned for the given srcCodesetId to the given tgtCategoryId. Specifying the srcCodesetId and tgtCategoryId are mandatory to clone the codeset.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `srcCodesetId` - int
      `createNewVersionIfExists` - boolean
      `tgtCategoryId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is cloned successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String
    Since:
      12.0

  - ### createEnvironmentAs

    public String createEnvironmentAs(String environment, String outputFormat)
    CSMEnvironment is added for the specified environment object. Specifying the environment name is mandatory, while creating the environment.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environment` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environment is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'CSMEnvironment' JSON :
      {
      "name": "",
      "auditHistory": null
      }

    Since:
      12.0

  - ### createEnvironmentsAs

    public String createEnvironmentsAs(String environments, String outputFormat)
    List of environments are added for the specified list of environment objects. Specification of the environment name in each environment object is mandatory while creating the environments.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environments` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environment are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'Environments' JsonArray :
      [
      {
      "name": "",
      "auditHistory": null
      },
      {
      "name": "",
      "auditHistory": null
      }
      ]

    Since:
      12.0

  - ### updateEnvironmentAs

    public String updateEnvironmentAs(String environment, String outputFormat)
    Updates the environment with the specified environment object. All the information related to the environment can be updated. Specifying the environmentId is mandatory to update the environment.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environment` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environment is updated successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'CSMEnvironment' JSON :
      {
      "id": 0,
      "name": "",
      "auditHistory": null
      }

    Since:
      12.0

  - ### getEnvironmentIdAs

    public String getEnvironmentIdAs(String environmentName, String outputFormat)
    Returns the environmentId for the specified environmentName. Specifying the environmentName is mandatory.
    It returns the environmentId
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - CSMEnvironmentId in the form of JSON or XML String.
    Since:
      12.0

  - ### getEnvironmentNameAs

    public String getEnvironmentNameAs(int environmentId, String outputFormat)
    Returns the environmen name for the specified environmentId. Specifying the environmentId is mandatory.
    It returns the environment name
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - CSMEnvironment name in the form of JSON or XML String.
    Since:
      12.0

  - ### getEnvironmentAs

    public String getEnvironmentAs(int environmentId, String outputFormat)
    Returns the environment object for the specified environmentId. Specifying the environmentId is mandatory.
    It returns all the details like environment name, description, auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - CSMEnvironment object in the form of JSON String.
    Since:
      12.0

  - ### getEnvironmentsAs

    public String getEnvironmentsAs(String outputFormat)
    Returns the list of environments along with all the details regarding each environment.
    Returns all the available environments as a list of environment objects.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of CSMEnvironment objects in the form of JSON or XML String
    Since:
      12.0

  - ### deleteEnvironmentAs

    public String deleteEnvironmentAs(int environmentId, String outputFormat)
    Deletes the environment with the specified environmentId. Specifying the environmentId is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environment is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteEnvironmentAs

    public String deleteEnvironmentAs(String environmentName, String outputFormat)
    Deletes the environment with the specified environmentName. Specifying the environmentName is mandatory to delete a particular environment.
    If the environment is deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environment is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String
    Since:
      12.0

  - ### deleteEnvironmentsAs

    public String deleteEnvironmentsAs(String environmentIds, String outputFormat)
    Deletes the environments with the specified list of environmentIds. Specifying the environmentIds list is mandatory.
    If the environments are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `environmentIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If environments are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### addCodeValueAs

    public String addCodeValueAs(String codeValue, boolean saveExtendedProperties, String outputFormat)
    Codevalue is added for the specified codeValue object and also extended properties are added only if the saveExtendedProperties flag is true. Specifying the codeset id, code name and value are mandatory while creating the codevalue.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValue` - String
      `saveExtendedProperties` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalue is added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'codeValueObj' JSON :
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }

    Since:
      12.0

  - ### addCodeValuesAs

    public String addCodeValuesAs(String codeValues, boolean saveExtendedProperties, String outputFormat)
    Codevalues are added for the specified list of codeValue objects and also extended properties are added only if the saveExtendedProperties flag is true. Specification of codeset id, code name and value in each codevalue object and saveExtendedProperties flag are mandatory.
    The supported date formats for the startDate and endDate are long value(1460701213000), YYYY-MM-DD and YYYY-MM-DDTHH:mm:ss formats.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValues` -
      `saveExtendedProperties` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are added successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'codeValuesObj' JSON :
      [
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      },
      {
      "codesetId": 0,
      "name": "",
      "value": "",
      "description": "",
      "auditHistory": null,
      "systemName": "",
      "systemEnvironmentName": "",
      "systemId": 0,
      "startDate": null,
      "endDate": null,
      "userDefinedField1": "",
      "userDefinedField2": "",
      "userDefinedField3": "",
      "userDefinedField4": "",
      "userDefinedField5": "",
      "userDefinedField6": "",
      "userDefinedField7": "",
      "userDefinedField8": "",
      "userDefinedField9": "",
      "userDefinedField10": "",
      "extendedProperties": [],
      "active": false,
      "deleteFlag": false
      }
      ]

    Since:
      12.0

  - ### getCodeValuesAs

    public String getCodeValuesAs(int categoryId, String codesetName, String outputFormat)
    Returns the list of codevalue objects for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of codevalue objects in the form of JSON String.
    Since:
      12.0

  - ### getCodeValuesAs

    public String getCodeValuesAs(int codesetId, String outputFormat)
    Returns the list of codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of codevalue objects in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodeValueAs

    public String deleteCodeValueAs(int codeValueId, String deleteMode, String outputFormat)
    Deletes the codevalue object with the specified codeValueId and deleteMode. Specifying the codeValueId is mandatory to delete a particular codeValue. If deleteMode is not specified the codevalue object will be purge deleted. Retired codevalues can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValueId` - int
      `deleteMode` - String - Valid values are RETIRE/PURGE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalue is deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodeValuesAs

    public String deleteCodeValuesAs(String codeValueIds, String deleteMode, String outputFormat)
    Deletes the list of codeValue objects with the specified codeValueIds list and deleteMode. Specifying the codeValueIds list mandatory to delete codevalues. If deleteMode is not specified the codevalue object will be purge deleted. Retired codevalues can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If the codeValues are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValueIds` - String
      `deleteMode` - String - Valid values are RETIRE/PURGE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### deleteCodeValuesAs

    public String deleteCodeValuesAs(int codesetId, String deleteMode, String outputFormat)
    Deletes the list of codevalue objects with the specified codesetId and deleteMode. Specifying the codesetId and deleteMode are mandatory to delete codevalues. If deleteMode is not specified the codevalue objects will be purge deleted. Retired codevalue's can be restored.
    Delete mode has values RETIRE, PURGE.
    RETIRE - The temporary delete can be restored.
    PURGE - The permanent delete, cannot be restored.
    If the codevalues are deleted all its associated data will also be deleted.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `deleteMode` - String - Valid values are RETIRE/PURGE.
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are deleted successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### importCodesetsAs

    public String importCodesetsAs(int categoryId, String importHelper, String outputFormat)
    Imports the codesets on the specified categoryId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the categoryId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `importHelper` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are imported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'ImportHelper' JSON :
      {
      "filePath" : "",
      "filePathType": ""
      }

    Since:
      12.0

  - ### importCodeValuesAs

    public String importCodeValuesAs(int codesetId, String importHelper, String outputFormat)
    Imports the codevalues on the specified codesetId. Specifying the filePath and filePathType are mandatory in importHelper object. The supported values for the filePathType are ABSOLUTE, RELATIVE. Here the the file in filePath given must be in xlsx or xls format only.
    Specifying the codesetId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `importHelper` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are imported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.

      Sample 'ImportHelper' JSON :
      {
      "filePath" : "",
      "filePathType": ""
      }

    Since:
      12.0

  - ### exportCodeValuesAs

    public String exportCodeValuesAs(int codesetId, String outputFormat)
    Codevalues are exported to excel for the specified codesetId.
    All the codevalues of the specified codesetId are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE. Specifying the codesetId is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are exported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### exportCodesetsAs

    public String exportCodesetsAs(int categoryId, boolean includeSubCategories, String outputFormat)
    Codesets are exported to excel for the specified categoryId. All the codesets of the specified categoryId are exported to excel, and sub category codesets are included only if the includeSubCategories flag is true.
    The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE. Specifying the categoryId and includeSubCategories flag are mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `includeSubCategories` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are exported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### exportAllAs

    public String exportAllAs(String outputFormat)
    All the codesets present in enterprise codesets are exported to excel. The exported filePath will be available in the userObject of requestStatus object and the filePath will be RELATIVE.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are exported successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### getLogicallyDeletedCodeValuesAs

    public String getLogicallyDeletedCodeValuesAs(int codesetId, String outputFormat)
    Returns the list of logically deleted codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of LogicallyDeletedCodeValues.
    Since:
      12.0

  - ### restoreCodeValuesAs

    public String restoreCodeValuesAs(String codeValueIds, String outputFormat)
    Retired codevalues can be restored for the specified codeValueIds. Specifying the codeValueIds list is mandatory.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codeValueIds` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codevalues are restored successfully, it will return RequestStatus object consisting of request success flag, status message and userObject etc... in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodeValuesAs

    public String getCodeValuesAs(int categoryId, String codesetName, int fillOptions, String outputFormat)
    Returns the list of codevalue objects for the specified categoryId and codesetName. Specifying the categoryId and codesetName are mandatory. Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If codeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `categoryId` - int
      `codesetName` - String
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of codevalue objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getCodeValuesAs

    public String getCodeValuesAs(int codesetId, int fillOptions, String outputFormat)
    Returns the list of codevalue objects for the specified codesetId. Specifying the codesetId is mandatory.Extended properties of each codevalue object are returned based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` If codeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions
    It returns all the details like code name, value, description, codesetId, and auditHistory details etc..
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `codesetId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of codevalue objects in the form of JSON or XML String.
    Since:
      12.0

  - ### getAllRetiredCodesetsAs

    public String getAllRetiredCodesetsAs(String outputFormat)
    Returns the list of all retired codesets present in enterprise codesets.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of retired codesets in the form of JSON or XML String.
    Since:
      12.0

  - ### assignCodesetAs

    public String assignCodesetAs(String nodeType, int nodeId, String codeset, String outputFormat)
    Assigns the specified codeset object to the specified nodeType and nodeId. Specifying the codeset object having codesetId, nodeType and nodeId are are mandatory.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `codeset` - String
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codeset is assigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### getAssignedCodesetsAs

    public String getAssignedCodesetsAs(String nodeType, int nodeId, int fillOptions, String outputFormat)
    Returns the list of codeset objects for the specified nodeType and nodeId. The returned codeset objects contains all the details pertaining to codeset such as codeset name, codeset description, codeset status and category name in which codeset is present etc.. and also contains details of codeValue and codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of either `APIConstants.CSMFillOptions.CODE_VALUES` or `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` Based on the value passed its related data is returned within the codeset object and if you want to get codeValues and codeValue extended properties then fillOptions parameter value will be addition of CODE_VALUES value and CODE_VALUE_EXTENDED_PROPERTIES value i.e 1+2=3 and so on.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String List of codesets in the form of JSON or XML String.
    Since:
      12.0

  - ### getValidValuesAs

    public String getValidValuesAs(String nodeType, int nodeId, int fillOptions, String outputFormat)
    Returns the list of codeValue objects for the specified nodeType and nodeId. The returned codeValue objects contains all the details pertaining to codeValue such as code name, code value, code description, codeset name in which codeValue is present etc..and also contains details of codeValue's extended properties based on the fillOptions parameter value passed with reference/addition of `APIConstants.CSMFillOptions`.
    Here fillOptions parameter takes value of `APIConstants.CSMFillOptions.CODE_VALUE_EXTENDED_PROPERTIES` whose value is 2. If fillOptions parameter value is passed as 2 then codeValue's extended properties are returned within the CodeValue object. If CodeValue's extended properties are not required then pass 0(zero) which is default value for fillOptions.
    Specification of nodeType and nodeId are mandatory. NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `fillOptions` - `APIConstants.CSMFillOptions` int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - List of codevalues in the form of JSON or XML String.
    Since:
      12.0

  - ### assignCodesetsAs

    public String assignCodesetsAs(String nodeType, int nodeId, String codesetIds, boolean unassignExisting, String outputFormat)
    Assigns codesets of specified codeset ids to the specified nodeType and nodeId. Specifying the nodeType, nodeId, list of codeset ids and unassignExisting flag are mandatory.
    UnassignExisting flag can be either true or false. If it is true then existing codesets of specified nodeId are unassigned if any and the new codesets are assigned. If it is false then the new codesets are assigned without unassiging existing codesets of nodeId.
    NodeType can be either SM_COLUMN or BGM_TERM. Depending upon the nodeType, nodeId will be either columnId or termId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `codesetIds` - String
      `unassignExisting` - boolean
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are assigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0

  - ### unassignExistingCodesetsAs

    public String unassignExistingCodesetsAs(String nodeType, int nodeId, String outputFormat)
    Unassigns existing codesets for the specified nodeType of nodeId. Specifying the nodeType and nodeId are mandatory, based on these it unassigns the existing codesets of a node.
    NodeType can be either BGM_TERM or SM_COLUMN. Depending upon the nodeType, nodeId will be either termId or columnId.
    OutputFormat can be either JSON or XML. If outputFormat is not specified, by default the method will return the JSON String.
    Parameters:
      `nodeType` - String
      `nodeId` - int
      `outputFormat` - String - Valid values: JSON or XML
    Returns:
      String - If codesets are unassigned successfully, it will return requestStatus object consisting of request success flag, status message and userObject etc.. in the form of JSON or XML String.
    Since:
      12.0